"use strict";
// Copyright (c) Mariana Meireles
// Distributed under the terms of the Modified BSD License.
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const base_1 = require("@jupyter-widgets/base");
var widgets = require('@jupyter-widgets/base');
const version_1 = require("./version");
// Import the CSS
require("../css/widget.css");
const cytoscape_1 = __importDefault(require("cytoscape"));
// @ts-ignore
const cytoscape_cola_1 = __importDefault(require("cytoscape-cola"));
// @ts-ignore
const cytoscape_popper_1 = __importDefault(require("cytoscape-popper"));
// @ts-ignore
const tippy_js_1 = __importDefault(require("tippy.js"));
// @ts-ignore
const cytoscape_dagre_1 = __importDefault(require("cytoscape-dagre"));
require("tippy.js/themes/material.css");
cytoscape_1.default.use(cytoscape_popper_1.default);
cytoscape_1.default.use(cytoscape_dagre_1.default);
cytoscape_1.default.use(cytoscape_cola_1.default);
class NodeModel extends base_1.WidgetModel {
    defaults() {
        return Object.assign({}, super.defaults(), { _model_name: NodeModel.model_name, _model_module: NodeModel.model_module, _model_module_version: NodeModel.model_module_version, _view_name: NodeModel.view_name, _view_module: NodeModel.view_module, _view_module_version: NodeModel.view_module_version, group: '', removed: false, selected: false, selectable: false, locked: false, grabbed: false, grabbable: false, classes: '', data: {}, position: {} });
    }
    ;
}
NodeModel.model_name = 'NodeModel';
NodeModel.model_module = version_1.MODULE_NAME;
NodeModel.model_module_version = version_1.MODULE_VERSION;
NodeModel.view_name = 'NodeView';
NodeModel.view_module = version_1.MODULE_NAME;
NodeModel.view_module_version = version_1.MODULE_VERSION;
exports.NodeModel = NodeModel;
class EdgeModel extends base_1.WidgetModel {
    defaults() {
        return Object.assign({}, super.defaults(), { _model_name: EdgeModel.model_name, _model_module: EdgeModel.model_module, _model_module_version: EdgeModel.model_module_version, 
            // _view_name: EdgeModel.view_name,
            // _view_module: EdgeModel.view_module,
            // _view_module_version: EdgeModel.view_module_version,
            group: '', removed: false, selected: false, selectable: false, locked: false, grabbed: false, grabbable: false, classes: '', data: {}, position: {} });
    }
    ;
}
EdgeModel.serializers = Object.assign({}, base_1.WidgetModel.serializers);
EdgeModel.model_name = 'EdgeModel';
EdgeModel.model_module = version_1.MODULE_NAME;
EdgeModel.model_module_version = version_1.MODULE_VERSION;
exports.EdgeModel = EdgeModel;
class GraphModel extends base_1.WidgetModel {
    defaults() {
        return Object.assign({}, super.defaults(), { _model_name: 'GraphModel', _model_module: GraphModel.model_module, _model_module_version: GraphModel.model_module_version, nodes: [], edges: [] });
    }
    ;
    converts_dict() {
        let graph = [];
        for (let i = 0; i < this.attributes.nodes.length; i++) {
            graph.push({ group: "nodes", data: this.attributes.nodes[i].get('data') });
        }
        for (let j = 0; j < this.attributes.edges.length; j++) {
            graph.push({ group: "edges", data: this.attributes.edges[j].get('data') });
        }
        return graph;
    }
}
GraphModel.serializers = Object.assign({ nodes: { deserialize: widgets.unpack_models }, edges: { deserialize: widgets.unpack_models } }, base_1.WidgetModel.serializers);
GraphModel.model_module = version_1.MODULE_NAME;
GraphModel.model_module_version = version_1.MODULE_VERSION;
exports.GraphModel = GraphModel;
class CytoscapeModel extends base_1.DOMWidgetModel {
    defaults() {
        return Object.assign({}, super.defaults(), { _model_name: CytoscapeModel.model_name, _model_module: CytoscapeModel.model_module, _model_module_version: CytoscapeModel.model_module_version, _view_name: CytoscapeModel.view_name, _view_module: CytoscapeModel.view_module, _view_module_version: CytoscapeModel.view_module_version, auto_unselectify: true, box_selection_enabled: false, cytoscape_layout: {}, cytoscape_style: [], elements: [], zoom: 0, rendered_position: {}, graph: null });
    }
}
CytoscapeModel.serializers = Object.assign({ graph: { deserialize: widgets.unpack_models } }, base_1.DOMWidgetModel.serializers);
CytoscapeModel.model_name = 'CytoscapeModel';
CytoscapeModel.model_module = version_1.MODULE_NAME;
CytoscapeModel.model_module_version = version_1.MODULE_VERSION;
CytoscapeModel.view_name = 'CytoscapeView';
CytoscapeModel.view_module = version_1.MODULE_NAME;
CytoscapeModel.view_module_version = version_1.MODULE_VERSION;
exports.CytoscapeModel = CytoscapeModel;
class NodeView extends base_1.WidgetView {
    constructor(params) {
        super({
            model: params.model,
            options: params.options
        });
        this.parentModel = this.options.parentModel;
        this.model.on('change:group', this.groupChanged, this);
        this.model.on('change:removed', this.removedChanged, this);
        this.model.on('change:selected', this.selectedChanged, this);
        this.model.on('change:locked', this.lockedChanged, this);
        this.model.on('change:grabbed', this.grabbedChanged, this);
        this.model.on('change:grabbable', this.grabbableChanged, this);
        this.model.on('change:classes', this.classesChanged, this);
        this.model.on('change:data', this.dataChanged, this);
        this.model.on('change:position', this.positionChanged, this);
    }
    //TODO: not sure if this is necessary to propagate the changes...
    groupChanged() {
        this.parentModel.set("group", this.model.get('group'));
    }
    removedChanged() {
        this.parentModel.set("removed", this.model.get('removed'));
    }
    selectedChanged() {
        this.parentModel.set("selected", this.model.get('selected'));
    }
    lockedChanged() {
        this.parentModel.set("locked", this.model.get('locked'));
    }
    grabbedChanged() {
        this.parentModel.set("grabbed", this.model.get('grabbed'));
    }
    grabbableChanged() {
        this.parentModel.set("grabbable", this.model.get('grabbable'));
    }
    classesChanged() {
        this.parentModel.set("classes", this.model.get('classes'));
    }
    dataChanged() {
        this.parentModel.set("data", this.model.get('data'));
    }
    positionChanged() {
        this.parentModel.set("position", this.model.get('position'));
    }
}
exports.NodeView = NodeView;
// export
// class EdgeView extends WidgetView {
//   parentModel: any;
//   constructor(params: any) {
//     super({
//       model: params.model,
//       options: params.options
//     }); 
//   this.parentModel = this.options.parentModel;
//   this.model.on('change:group', this.groupChanged, this);
//   this.model.on('change:removed', this.removedChanged, this);
//   this.model.on('change:selected', this.selectedChanged, this);
//   this.model.on('change:locked', this.lockedChanged, this);
//   this.model.on('change:grabbed', this.grabbedChanged, this);
//   this.model.on('change:grabbable', this.grabbableChanged, this);
//   this.model.on('change:classes', this.classesChanged, this);
//   this.model.on('change:data', this.dataChanged, this);
//   this.model.on('change:position', this.positionChanged, this);
//   }
//   //TODO: not sure if this is necessary to propagate the changes...
//   groupChanged() {
//     this.parentModel.set("group", this.model.get('group'));
//   }
//   removedChanged() {
//     this.parentModel.set("removed", this.model.get('removed'));
//   }
//   selectedChanged() {
//     this.parentModel.set("selected", this.model.get('selected'));
//   }
//   lockedChanged() {
//     this.parentModel.set("locked", this.model.get('locked'));
//   }
//   grabbedChanged() {
//     this.parentModel.set("grabbed", this.model.get('grabbed'));
//   }
//   grabbableChanged() {
//     this.parentModel.set("grabbable", this.model.get('grabbable'));
//   }
//   classesChanged() {
//     this.parentModel.set("classes", this.model.get('classes'));
//   }
//   dataChanged() {
//     this.parentModel.set("data", this.model.get('data'));
//   }
//   positionChanged() {
//     this.parentModel.set("position", this.model.get('position'));
//   }
// }
class CytoscapeView extends base_1.DOMWidgetView {
    constructor() {
        super(...arguments);
        this.is_rendered = false;
        this.nodeViews = [];
        this.edgeViews = [];
        // addEdgeModel(EdgeModel: any) {
        //   console.log('adding edge model')
        //     return this.create_child_view(EdgeModel, {
        //         cytoscapeView: this,
        //         parentModel: this.model,
        //     });
        // }
        // removeEdgeView(edgeView: any) {
        //     edgeView.remove();
        // }
    }
    render() {
        this.el.classList.add('custom-widget');
        this.nodeViews = new widgets.ViewList(this.addNodeModel, this.removeNodeView, this);
        this.nodeViews.update(this.model.get('graph').get('nodes'));
        // this.edgeViews = new widgets.ViewList(this.addEdgeModel, this.removeEdgeView, this);
        // this.edgeViews.update(this.model.get('graph').get('edges'));
        this.value_changed();
        this.model.get('graph').on('change:nodes', this.value_changed, this);
        this.model.get('graph').on('change:edges', this.value_changed, this);
        //TODO: not sure if these are useful, the one for style is not
        //but for layout it seems to make a difference. Need to test and
        //remove the ones that are not and figure out why
        this.model.on('change:auto_unselectify', this.value_changed, this);
        this.model.on('change:box_selection_enabled', this.value_changed, this);
        this.model.on('change:cytoscape_layout', this.value_changed, this);
        this.model.on('change:cytoscape_style', this.value_changed, this);
        this.model.on('change:elements', this.value_changed, this);
        this.displayed.then(() => {
            this.init_render();
        });
    }
    value_changed() {
        if (this.is_rendered) {
            console.log('value_changed');
            this.init_render();
        }
    }
    init_render() {
        if (this.model.get('graph') != null) {
            this.is_rendered = true;
            this.cytoscape_obj = cytoscape_1.default({
                container: this.el,
                autounselectify: this.model.get('auto_unselectify'),
                boxSelectionEnabled: this.model.get('box_selection_enabled'),
                layout: this.model.get('cytoscape_layout'),
                style: this.model.get('cytoscape_style'),
                elements: this.model.get('graph').converts_dict()
            });
            this.cytoscape_obj.on('click', 'node', (e) => {
                let node = e.target;
                let ref = node.popperRef();
                let dummyDomEle = document.createElement('div');
                if (node.data().name) {
                    let tip = tippy_js_1.default(dummyDomEle, {
                        //TODO: add a pretty tippy
                        trigger: 'manual',
                        lazy: false,
                        arrow: true,
                        theme: 'material',
                        placement: 'bottom',
                        content: () => {
                            /*
                              TODO:
                              Currently this function is mapping to one attribute inside
                              nodes[data], which in this case is name.
                              The backend is using that to import various datas from
                              DataFrames, the problem is that data will appear unformatted.
                              Not even line breaks are working for some reason.
                              Make the visualization better, see issue: #33
                            */
                            let content = document.createElement('div');
                            content.innerHTML = node.data().name;
                            return content;
                        },
                        onCreate: instance => { instance.popperInstance.reference = ref; }
                    });
                    tip.show();
                }
            });
        }
    }
    addNodeModel(NodeModel) {
        return this.create_child_view(NodeModel, {
            cytoscapeView: this,
            parentModel: this.model,
        });
    }
    removeNodeView(nodeView) {
        nodeView.remove();
    }
}
exports.CytoscapeView = CytoscapeView;
//# sourceMappingURL=widget.js.map